#define NAME(x)  _NAME(x)
#define _NAME(x) #x  
#define DEBUG_PRINT(x) 	printf("[" NAME(S_FUNCTION_NAME) "] : " x "\n")

#ifdef MEX_FUNCTION_FLOULIB
#define ERROR(x) mexErrMsgTxt("[" NAME(S_FUNCTION_NAME) "] : " x "\n")
#else
#define ERROR(x) ssSetErrorStatus(S,"[" NAME(S_FUNCTION_NAME) "] : " x "\n")
#endif

#define STRING(x) #x

// Debuging messages

#define START_MDLINITIALIZESIZES 					"Start mdlInitializeSizes"
#define END_MDLINITIALIZESIZES						"End mdlInitializeSizes"
#define START_MDLSTART			     					"Start mdlStart"
#define END_MDLSTART		     					    	"End mdlStart"
#define START_MDLOUTPUTS								"Start mdlOutputs"
#define END_MDLOUTPUTS									"End mdlOutputs"
#define START_MDLTERMINATE								"Start mdlTerminate"
#define END_MDLTERMINATE								"End mdlTerminate"

#define START_INITIALISATION							"Start Initialisation"
#define END_INITIALISATION								"End Initialisation"
#define START_INITIALISATION_FLC						"Start InitialisationFLC"
#define END_INITIALISATION_FLC						"End InitialisationFLC"
#define START_INITPARTITION							"Start InitPartition"
#define END_INITPARTITION								"End InitPartition"
#define START_READ_NB_INPUT							"Start ReadNbInput"
#define END_READ_NB_INPUT								"End ReadNbInput"
#define START_READ_RULES								"Start ReadRules"
#define END_READ_RULES									"End ReadRules"
#define START_READ_NB_RULES							"Start ReadNbRules"
#define END_READ_NB_RULES								"End ReadNbRules"
#define START_READ_OPERATORS							"Start ReadOperators"
#define END_READ_OPERATORS								"End ReadOperators"
#define START_INITATTRIBUTES							"Start InitAttributes"
#define END_INITATTRIBUTES								"End InitAttributes"

// Error messages

#define ERR_ALLOC_MEM									"Incorrect memory allocation"
#define ERR_ALLOC_MEM_CREATION						"Incorrect memory allocation when creating the project"
#define ERR_ALLOC_MEM_INIT								"Incorrect memory allocation in Initialisation"
#define ERR_ALLOC_MEM_RECHERCHE						"Incorrect memory allocation in Search"


#define ERR_ALLOC_MEM_FUZ								"Incorrect memory allocation in fuzzification"
#define ERR_ALLOC_MEM_FUZ_SUP							"Incorrect memory allocation in upper fuzzification"
#define ERR_ALLOC_MEM_FUZ_INF							"Incorrect memory allocation in lower fuzzification"
#define ERR_ALLOC_MEM_PARTITION_MISO				"Incorrect memory allocation in PartitionMISO"
#define ERR_ALLOC_MEM_INITPARTITION					"Incorrect memory allocation in InitPartition"
#define ERR_ALLOC_MEM_INITATTRIBUTES				"Incorrect memory allocation in InitAttributes"
#define ERR_ALLOC_MEM_INITPARTITION_REF			"Incorrect memory allocation in InitPartition - reference"
#define ERR_ALLOC_MEM_INITPARTITION_TABREF	 	"Incorrect memory allocation in InitPartition - table reference"
#define ERR_ALLOC_MEM_CREATION_TABRULE				"Incorrect memory allocation when creating TabRule"
#define ERR_ALLOC_MEM_CREATION_SIZEDTABRULE				"Incorrect memory allocation when creating SizedTabRule"
#define ERR_ALLOC_MEM_CREATION_RULES				"Incorrect memory allocation when creating the rules"
#define ERR_AT_LEAST_ONE_INPUT						"Block must have at least one input"
#define ERR_DEFUZ_NULL_NUMBER_OF_POINTS			"Number of points should not be null with this defuzzification method"
#define ERR_FILE_OPEN									"The file cannot be opened"	
#define ERR_FILE_READ									"The file cannot be read"
#define ERR_INCOHERENCE_RULE_PART1					"Incoherence in rule "
#define ERR_INCOHERENCE_RULE_PART2					" for the symbol "
#define ERR_MAX_PT_2D          				      "The maximum number of points has been reached."
#define ERR_MAX_TRIANGLE_2D      			      "The maximum number of triangles has been reached"
#define ERR_NB_OUTPUT_SYMBOL						   "The number of symbols in the conclusion is not coherent with the number of output symbols in the file (second parameter on the first line)"
#define ERR_NB_SYMBOL_DEFUZ						   "The number of symbols for the defuzzification file is not coherent with the inference result"
#define ERR_NO_RULE_ACTIVE								"The output cannot be computed - No rule is active."
#define ERR_NO_TRIANGLE_2D      						"No triangle 2D was created with the new point"
#define ERR_NOT_A_TRIANGLE       					"The three poids do not define a triangle"
#define ERR_ONE_PARAMETER								"Function must be called with one parameter"
#define ERR_PARAM_ADAP									"Parameter must be +, -, *, /"
#define ERR_PARAM_SCALAR								"Parameter must be a number"
#define ERR_PARAM_STRING								"Parameter must be a string"
#define ERR_PARAM1_EQUAL_1_OR_SUP_EQUAL_5			"The first parameter must be equla to 1 or greater or equal than 5"
#define ERR_PARAM2_NEGATIVE							"The second parameter must be negative or null"
#define ERR_PARAM3_POSITIVE							"The third parameter must be positive or null"
#define ERR_POINT_OUT_OF_TRIANGLE 					"The point does not belong to a triangle"
#define ERR_SIGN											"Parameter must contain only + or - signs"
#define ERR_STRING_NULL									"The string must not be null"
#define ERR_STRING_X           						"Linguistic terms are limited to" STRING(_X) " caracters"
#define ERR_THREE_PARAM									"Function must be called with three parameters"
#define ERR_TWO_PARAM									"Function must be called with two parameters"
#define ERR_UNKNOWN_COMP								"Unknown comparison method"
#define ERR_UNKNOWN_DEFUZ						      "Unknown defuzzification method"
#define ERR_UNKNOWN_OPERATOR							"Unknown fuzzy operator"
#define ERR_UNKNOWN_SYMBOL								"Unknown Symbol"
#define ERR_UNKNOWN_SYMBOL_DEFUZ						"One of the symbol in the defuzzification is not in the inference result"
#define ERR_UNKNOWN_TCONORM			 				"Unknown conorm"
#define ERR_UNKNOWN_TNORM							   "Unknown norm"


// Messages en Franais
#ifdef FR

// Messages pour la mise au point 
#define START_MDLINITIALIZESIZES 					"Dbut mdlInitializeSizes"
#define END_MDLINITIALIZESIZES						"Fin mdlInitializeSizes"
#define START_MDLSTART			     					"Dbut mdlStart"
#define END_MDLSTART		     					    	"Fin mdlStart"
#define START_MDLOUTPUTS								"Dbut mdlOutputs"
#define END_MDLOUTPUTS									"End mdlOutputs"
#define START_MDLTERMINATE								"Dbut mdlTerminate"
#define END_MDLTERMINATE								"End mdlTerminate"
#define START_INITIALISATION							"Dbut Initialisation"
#define END_INITIALISATION								"Fin Initialisation"
#define START_INITIALISATION_FLC						"Dbut InitialisationFLC"
#define END_INITIALISATION_FLC						"Fin InitialisationFLC"
#define START_INITPARTITION							"Dbut InitPartition"
#define END_INITPARTITION								"Fin InitPartition"
#define START_READ_NB_INPUT							"Dbut ReadNbInput"
#define END_READ_NB_INPUT								"Fin ReadNbInput"
#define START_READ_RULES								"Dbut ReadRules"
#define END_READ_RULES									"Fin ReadRules"
#define START_READ_NB_RULES							"Dbut ReadNbRules"
#define END_READ_NB_RULES								"Fin ReadNbRules"
#define START_READ_OPERATORS							"Dbut ReadOperators"
#define END_READ_OPERATORS								"Fin ReadOperators"
#define START_INITATTRIBUTES							"Dbut InitAttributes"
#define END_INITATTRIBUTES								"Fin InitAttributes"

// Message d'erreur
#define ERR_ALLOC_MEM									"Allocation mmoire impossible"
#define ERR_ALLOC_MEM_CREATION						"Problme d'allocation mmoire  la cration du Projet"
#define ERR_ALLOC_MEM_CREATION_RULES				"Problme d'allocation mmoire dans la cration des rgles"
#define ERR_ALLOC_MEM_CREATION_TABRULE				"Problme d'allocation mmoire dans la cration de TabRegle"
#define ERR_ALLOC_MEM_CREATION_SIZEDTABRULE				"Problme d'allocation mmoire dans la cration de SizedTabRegle"
#define ERR_ALLOC_MEM_FUZ								"Probleme d'allocation mmoire dans la fuzzification"
#define ERR_ALLOC_MEM_FUZ_INF							"Probleme d'allocation mmoire dans la fuzzification infrieure"
#define ERR_ALLOC_MEM_FUZ_SUP							"Probleme d'allocation mmoire dans la fuzzification suprieure"
#define ERR_ALLOC_MEM_INIT								"Problme d'allocation mmoire dans Initialisation"
#define ERR_ALLOC_MEM_INITATTRIBUTES				"Problme d'allocation mmoire dans InitAttributes"
#define ERR_ALLOC_MEM_INITPARTITION					"Problme d'allocation mmoire dans InitPartition"
#define ERR_ALLOC_MEM_INITPARTITION_REF			"Problme d'allocation mmoire dans InitPartition - rfrentiel"
#define ERR_ALLOC_MEM_INITPARTITION_TABREF	 	"Problme d'allocation mmoire dans InitPartition - tableau rfrentiel"
#define ERR_ALLOC_MEM_PARTITION_MISO				"Problme d'allocation mmoire  la cration de la PartitionMISO"
#define ERR_ALLOC_MEM_RECHERCHE						"Problme d'allocation mmoire dans Recherche"
#define ERR_AT_LEAST_ONE_INPUT						"Le bloc doit comporter au moins une  entre"
#define ERR_DEFUZ_NULL_NUMBER_OF_POINTS			"Le nombre de points ne doit pas tre nul avec cette mthode de dfuzzification"
#define ERR_FILE_OPEN									"Ouverture du fichier impossible"	
#define ERR_FILE_READ									"Lecture du fichier impossible"
#define ERR_INCOHERENCE_RULE_PART1					"Problme d'incohrence dans la rgle "
#define ERR_INCOHERENCE_RULE_PART2					" pour le symbole "
#define ERR_MAX_PT_2D          				      "Le nombre maximun de points a t atteint"
#define ERR_MAX_TRIANGLE_2D      			      "Le nombre maximun de triangles a t atteint"
#define ERR_NB_OUTPUT_SYMBOL						   "Le nombre de symboles dclar en sortie du bloc n'est pas cohrent avec le contenu du fichier"
#define ERR_NB_SYMBOL_DEFUZ						   "Le nombre de symboles dclar pour la dfuzzification n'est pas cohrent avec le rsultat de l'infrence"
#define ERR_NO_RULE_ACTIVE								"Calcul de la sortie impossible - aucune rgle active"
#define ERR_NOT_A_TRIANGLE       					"Les trois points ne forment pas un triangle"
#define ERR_NO_TRIANGLE_2D      						"Aucun triangle 2D n'a t cr avec le nouveau point"
#define ERR_ONE_PARAMETER								"Il doit y avoir un paramtre"
#define ERR_PARAM_ADAP									"Le paramtre doit tre +, -, *, /"
#define ERR_PARAM_SCALAR								"Le paramtre doit tre un scalaire"
#define ERR_PARAM_STRING								"Le paramtre doit tre une chane"
#define ERR_PARAM1_EQUAL_1_OR_SUP_EQUAL_5			"Le premier paramtre doit tre gal  1 ou suprieur ou gal  5"
#define ERR_PARAM2_NEGATIVE							"Le second paramtre doit tre ngatif ou nul"
#define ERR_PARAM3_POSITIVE							"Le troisime paramtre doit tre positif ou nul"
#define ERR_POINT_OUT_OF_TRIANGLE 					"Le point n'appartient  aucun triangle"
#define ERR_SIGN											"Le paramtre ne doit comporter que des signes + ou -"
#define ERR_STRING_NULL									"La chane ne doit pas tre vide"
#define ERR_STRING_X           						"Les symboles sont limits  " STRING(_X) " caractres"
#define ERR_THREE_PARAM									"Il doit y avoir trois paramtres"
#define ERR_TWO_PARAM									"Il doit y avoir deux paramtres"
#define ERR_UNKNOWN_COMP								"Mthode de comparaison inconnue"
#define ERR_UNKNOWN_DEFUZ						      "Mthode de dfuzzification inconnue"
#define ERR_UNKNOWN_OPERATOR							"Oprateur flou inconnu"
#define ERR_UNKNOWN_SYMBOL								"Symbole inconnu"
#define ERR_UNKNOWN_SYMBOL_DEFUZ						"Un des symboles utiliss pour la dfuzzification n'existe pas dans le rfrentiel li  l'infrence"
#define ERR_UNKNOWN_TCONORM			 				"Conorme triangulaire inconnue"
#define ERR_UNKNOWN_TNORM						   	"Norme triangulaire inconnue"
#endif
